/*
 * Quasseldroid - Quassel client for Android
 *
 * Copyright (c) 2021 Janne Mareike Koschinski
 * Copyright (c) 2021 The Quassel Project
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 3 as published
 * by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program. If not, see <http://www.gnu.org/licenses/>.
 */

package de.kuschku.quasseldroid.util

import androidx.core.view.ViewCompat.LAYOUT_DIRECTION_RTL
import androidx.customview.widget.ViewDragHelper
import androidx.drawerlayout.widget.DrawerLayout

fun DrawerLayout.setEdgeSize(edgeSize: Int) {
  val resources = context.resources
  val rtl = resources.configuration.layoutDirection == LAYOUT_DIRECTION_RTL
  val density = resources.displayMetrics.density

  val dragger: ViewDragHelper = getField(if (rtl) "mRightDragger" else "mLeftDragger") ?: return
  dragger.setField("mEdgeSize", (edgeSize * density + 0.5f).toInt())
}
